#include <Xm/Xm.h>
#include <Xm/TextF.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "errormsg.h"
#include "getdir.h"
#include "defines.h"
#include "filearea.h"
#include "permission.h"

extern Widget fm_container, fm_textfield;
extern char current_wd[120];

/* Open file triggered by double-click or activate in text field. */
void fm_openitem(Widget w, XtPointer client_data, XtPointer call_data)
{
  char fm_file[40], to_open[150], exec_this[155], *mptr;
  WidgetList sel_wid;
  int sel_wid_count, t1;
  struct stat buf;

  if ((int)client_data == 10) {
    mptr = XmTextFieldGetString(fm_textfield);
    strcpy(to_open, mptr);
    XtFree(mptr);
  }
  else
    {
      XtVaGetValues(fm_container, XmNselectedObjects, &sel_wid, 
		    XmNselectedObjectCount, &sel_wid_count, NULL);
      strcpy(fm_file, XtName(sel_wid[0]));
      if (sel_wid_count == 1) {
	if (strcmp(fm_file, ".") == 0)
	  return;
	if (strcmp(fm_file, "..") == 0)
	  sprintf(to_open, "%s", getparent());
	else
	  if (strcmp(current_wd, "/"))
	    sprintf(to_open, "%s/%s", current_wd, XtName(sel_wid[0]));
	  else
	    sprintf(to_open, "/%s", XtName(sel_wid[0]));
      }
    }
	     
#ifdef DEBUG
  printf("%s\n", to_open);
#endif
  stat(to_open, &buf);
  if (t1 && (errno == ENOENT)) {
    NoCanDo(DIR_NOT_EXIST);
    return;
  }
  if (S_ISDIR(buf.st_mode)) {
    if (IsReadable(buf) && IsExecutable(buf)) {
#ifdef DEBUG
      printf("opening directory...\n");
#endif
      load_dir(to_open);
#ifdef DEBUG
      printf("drawing directory...\n");
#endif
      DrawFileArea();
    }
    else
      NoCanDo(CANT_READ_DIR);
    return;
  }
  if (IsExecutable(buf)) {
    sprintf(exec_this, "%s &", to_open);
    system(exec_this);
    return;
  }
  if (buf.st_mode & 73) {
    NoCanDo(CANT_EXECUTE);
    return;
  }
  NoCanDo(NOT_EXECUTABLE);
}







